<?php

namespace Drupal\ajax\Normalizer;

use Drupal\commerce_order\Entity\Order;
use Drupal\commerce_product\Entity\ProductVariation;
use Drupal\file\Entity\File;
use Drupal\node\Entity\Node;

use Drupal\node\NodeInterface;
use Drupal\serialization\Normalizer\ContentEntityNormalizer;

class NodeEntityNormalizer extends ContentEntityNormalizer
{

  /**
   * {@inheritdoc}
   */
  public function __construct()
  {
    $this->supportedInterfaceOrClass = ProductVariation::class;
  }
  public function normalize($object, $format = NULL, array $context = []) {
    //получаю небходимые атрибуты при обращении к апи корзины, в моем случае - при добавлении в корзину вариации продукта коммерса.
    $attributes = parent::normalize($object, $format, $context);
    //получаю продукт коммерца, в котором хранится ссылка на нужную ноду, где нужно взять картинку
    $node = \Drupal::entityTypeManager()
      ->getStorage('commerce_product')
      ->loadByProperties([
        'type' => 'odezhda',
        'product_id' => $attributes['product_id'],
      ]);
    // получаю конкретную ноду продукта коммерца , чтобы не использовать foreach для одного элемента ( т к id у нас в единственном экз)
    $product = $node[$attributes['product_id']];
    // получаю ноду продукта
    $node = \Drupal::entityTypeManager()
      ->getStorage('node')
      ->loadByProperties([
        'type' => 'products',
        'nid' => $product->field_products->target_id,
      ]);
    $conc_product = $node[$product->field_products->target_id];
    // получаю id картинки
    $image_id = $conc_product->field_image->target_id;
    //получаю url картинки
    $first_file = File::load($image_id);
    $first_url = $first_file->createFileUrl();
    //создаю поле картинки в апи ответе корзины
    $attributes['image_url'] = $first_url;
    return $attributes;
  }
}
